<template>
  <div class="container">
    <img
      class="logo"
      :src="currentLogo"
    >
    <h2>Entre com sua conta</h2>
    <a-form
      :form="form"
      class="login-form"
      autocomplete="off"
      @submit="handleSubmit"
    >
      <a-form-item
        label="Login"
        class="input-icon"
      >
        <a-input
          v-decorator="[
            'email',
            {rules: [{ required: true, message: 'Por favor digite seu login!' }]}
          ]"
          placeholder="Digite seu login"
          type="email"
        >
          <a-icon
            slot="prefix"
            type="user"
          />
        </a-input>
      </a-form-item>

      <a-form-item
        label="Senha"
        class="input-icon"
      >
        <a-input
          v-decorator="[
            'password',
            {rules: [{ required: true, message: 'Por favor digite sua senha!' }]}
          ]"
          type="password"
          placeholder="Digite sua senha"
        >
          <a-icon
            slot="prefix"
            type="lock"
          />
        </a-input>
      </a-form-item>

      <p
        v-if="$store.state.auth.loginError"
        class="loginError"
      >
        Ocorreu algum erro ao fazer login. Verifique se os dados estão corretos.
      </p>

      <a-form-item>
        <a-button
          html-type="submit"
          type="primary"
          class="submit-button"
          :disabled="$store.state.auth.loggingIn"
        >
          <span v-if="$store.state.auth.loggingIn">
            <a-icon type="loading" />
          </span>
          <span v-else>Fazer login</span>
        </a-button>
      </a-form-item>
    </a-form>
  </div>
</template>

<script>
import { mapActions } from 'vuex';

export default {
  name: 'Login',
  data() {
    return {
      form: this.$form.createForm(this),
      currentLogo: '',
    };
  },
  async created() {
    const fetch = await this.$http.get('/headers');
    this.currentLogo = fetch.data[0].logo;
  },
  methods: {
    ...mapActions('auth', [
      'login',
    ]),
    handleSubmit(e) {
      e.preventDefault();
      this.form.validateFields((err, values) => {
        if (!err) {
          this.login(values);
        }
      });
    },
  },
};
</script>

<style lang="stylus" scoped>
.input-icon
  width 100%
  margin-top 2rem
  margin-bottom 2rem

  .anticon-close-circle
    cursor pointer
    color var(--color-gray)
    transition color 0.3s
    font-size: 1.2rem

    &:hover
      color #999

    &:active
      color #666

.container
  width 100%
  height 100vh
  display flex
  flex-direction column
  align-items center
  justify-content center

.login-form
  max-width 50rem
  width 100%
  padding: 0 2rem;

.logo
  margin-bottom 4rem
  height 10rem

.loginError
  color #ff0000
</style>
